////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                //
// BeDVI                                                                                                          //
// by Achim Blumensath                                                                                            //
// blume@corona.oche.de                                                                                           //
//                                                                                                                //
// This program is free software! It may be distributed according to the GNU Public License (see COPYING).        //
//                                                                                                                //
// $Id: BeDVI.h,v 1.4 1997/04/27 17:41:29 achim Exp achim $
//                                                                                                                //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef VIEWDVI_H
#define VIEWDVI_H

#ifndef _APPLICATION_H
#include <Application.h>
#endif
#ifndef DEFINES_H
#include "defines.h"
#endif
#ifndef DVI_H
#include "DVI.h"
#endif

#include "Support.h"

class BPositionIO;
class DisplayInfo;
class DStream;
class DVIView;
class ViewWindow;

#define VERSION "V1.3"

// Messages:

static const u_long MsgOpenPanel    = MAKE_ID('o', 'p', 'n', 'l');
static const u_long MsgOpenFile     = MAKE_ID('o', 'p', 'e', 'n');
static const u_long MsgAntiAliasing = MAKE_ID('g', 'r', 'e', 'y');
static const u_long MsgBorderLine   = MAKE_ID('b', 'o', 'r', 'd');
static const u_long MsgMeasureWin   = MAKE_ID('m', 'w', 'i', 'n');
static const u_long MsgSearch       = MAKE_ID('f', 'i', 'n', 'd');
static const u_long MsgNext         = MAKE_ID('n', 'e', 'x', 't');
static const u_long MsgPrev         = MAKE_ID('p', 'r', 'e', 'v');
static const u_long MsgFirst        = MAKE_ID('f', 'i', 'r', 's');
static const u_long MsgLast         = MAKE_ID('l', 'a', 's', 't');
static const u_long MsgSaveSettings = MAKE_ID('s', 'v', 's', 't');
static const u_long MsgPage         = MAKE_ID('p', 'a', 'g', 'e');

class ViewApplication: public BApplication
{
  private:
    ViewWindow  *win;
    DVIView     *vw;
    BFilePanel  *OpenPanel;
    entry_ref   PanelDirectory;
//    BMessage    *FilePanelMsg;

  public:
    // settings:

    DVISettings Settings;
    BRect       WindowBounds;

            ViewApplication();
    virtual ~ViewApplication();

    virtual void ArgvReceived(int32 argc, char **argv);
    virtual void RefsReceived(BMessage *msg);
    virtual bool QuitRequested();
    virtual void AboutRequested();
    virtual void CloseFilePanel();
    virtual void MessageReceived(BMessage *msg);

    void LaunchFilePanel();
    void OpenFile(entry_ref File);
    void SetResolution(u_int PixelsPerInch, u_int ShrinkFactor);
    void ToggleAntiAliasing();
    void UpdateMenus();

    static void DisplayError(const char *msg);

    bool Ok()
    {
      return win != NULL && vw != NULL;
    }
};

bool       InitAppMenu();
ViewWindow *InitWindow();
void       SetSleepCursor();
void       SetNormalCursor();

#endif
